# borg export-tar

    borg [common options] export-tar [options] NAME FILE [PATH...]

positional arguments
| `NAME` | specify the archive name
| `FILE` | output tar file. “-” to write to stdout instead.
| `PATH` | paths to extract; patterns are supported
options
| `--tar-filter` | filter program to pipe data through
| `--list` | output verbose list of items (files, dirs, …)
| `--tar-format FMT` | select tar format: BORG, PAX or GNU
| `--sparse` | write sparse tar members (GNU sparse format 1.0) for files containing all-zero chunks (BORG and PAX formats only)
Common options
Include/Exclude options
| `-e PATTERN`, `--exclude PATTERN` | exclude paths matching PATTERN
| `--exclude-from EXCLUDEFILE` | read exclude patterns from EXCLUDEFILE, one per line
| `--pattern PATTERN` | include/exclude paths matching PATTERN
| `--patterns-from PATTERNFILE` | read include/exclude patterns from PATTERNFILE, one per line
| `--strip-components NUMBER` | Remove the specified number of leading path elements. Paths with fewer elements will be silently skipped.

## Description

This command creates a tarball from an archive.

When giving ‘-’ as the output FILE, Borg will write a tar stream to standard output.

By default (`--tar-filter=auto`) Borg will detect whether the FILE should be compressed based on its file extension and pipe the tarball through an appropriate filter before writing it to FILE:

- .tar.gz or .tgz: gzip

- .tar.bz2 or .tbz: bzip2

- .tar.xz or .txz: xz

- .tar.zstd, .tar.zst or .tzst: zstd (in-process, level 3)

- .tar.lz4: lz4

For zstd, Borg compresses in-process using libzstd instead of piping through an external program (set BORG_ZSTD_MT_WORKERS to use multiple compression threads). The other formats are piped through the respective external filter program.

Alternatively, a `--tar-filter` program may be explicitly specified. It should read the uncompressed tar stream from stdin and write a compressed/filtered tar stream to stdout.

Depending on the `--tar-format` option, these formats are created:

--tar-format | Specification | Metadata
BORG | BORG specific, like PAX | all as supported by borg
PAX | POSIX.1-2001 (pax) format | GNU + atime/ctime/mtime ns + xattrs
GNU | GNU tar format | mtime s, no atime/ctime, no ACLs/xattrs/bsdflags

With `--sparse`, files whose content contains runs of all-zero chunks are written as sparse tar members (GNU sparse format 1.0, as GNU tar creates it in POSIX mode), storing only a hole map and the non-zero data. This requires `--tar-format BORG` or `PAX`. Such tarballs can be much smaller for sparse files (e.g. disk images) and extract to sparse files again with GNU tar’s or bsdtar’s sparse support (as well as with `borg import-tar` / `borg extract --sparse`). Notes: hole detection works at the granularity of borg’s content chunks (it does not depend on the original file having been a sparse file - but some short or unaligned zero runs may be stored literally); sparse-unaware tar implementations will extract a member as `GNUSparseFile.0/<name>` containing the raw hole map and data (the same caveat applies to tarballs created by GNU tar); for members needing >= 8 GiB of stored (non-hole) data, the stored size is base-256 encoded in the tar header (the GNU/star encoding of big numbers, understood by GNU tar, libarchive/bsdtar and python) - logical file sizes are unlimited anyway.

By default the entire archive is extracted but a subset of files and directories can be selected by passing a list of `PATHs` as arguments. The file selection can further be restricted by using the `--exclude` option.

For more help on include/exclude patterns, see the borg help patterns command output.

`--progress` can be slower than no progress display, since it makes one additional pass over the archive metadata.

# borg import-tar

    borg [common options] import-tar [options] NAME TARFILE

positional arguments
| `NAME` | specify the archive name
| `TARFILE` | input tar file. “-” to read from stdin instead.
options
| `--tar-filter` | filter program to pipe data through
| `-s`, `--stats` | print statistics for the created archive
| `--list` | output verbose list of items (files, dirs, …)
| `--filter STATUSCHARS` | only display items with the given status characters
| `--json` | output stats as JSON (implies --stats)
| `--ignore-zeros` | ignore zero-filled blocks in the input tarball
Common options
Archive options
| `--comment COMMENT` | add a comment text to the archive
| `--timestamp TIMESTAMP` | manually specify the archive creation date/time (yyyy-mm-ddThh:mm:ss[(+|-)HH:MM] format, (+|-)HH:MM is the UTC offset, default: local time zone). Alternatively, give a reference file/directory.
| `--chunker-params PARAMS` | specify the chunker parameters (ALGO, CHUNK_MIN_EXP, CHUNK_MAX_EXP, HASH_MASK_BITS, NC_LEVEL). default: fastcdc,19,23,21,2
| `-C COMPRESSION`, `--compression COMPRESSION` | select compression algorithm, see the output of the “borg help compression” command for details.
| `--digests ALGOS` | compute these hash digests over the full content of each file and store them into the archive items. Comma-separated list of hash algorithm names, e.g. “blake3”, or “none”. default: none

## Description

This command creates a backup archive from a tarball.

When giving ‘-’ as path, Borg will read a tar stream from standard input.

By default (--tar-filter=auto) Borg will detect whether the file is compressed based on its file extension and pipe the file through an appropriate filter:

- .tar.gz or .tgz: gzip -d

- .tar.bz2 or .tbz: bzip2 -d

- .tar.xz or .txz: xz -d

- .tar.zstd, .tar.zst or .tzst: zstd (in-process)

- .tar.lz4: lz4 -d

For zstd, Borg decompresses in-process using libzstd instead of piping through an external program. The other formats are piped through the respective external filter program.

Alternatively, a --tar-filter program may be explicitly specified. It should read compressed data from stdin and output an uncompressed tar stream on stdout.

Most documentation of borg create applies. Note that this command does not support excluding files.

A `--sparse` option (as found in borg create) is not needed: sparse members in input tarballs (old GNU and PAX sparse formats) are read correctly and their holes are stored as deduplicated all-zero chunks.

About tar formats and metadata conservation or loss, please see `borg export-tar`.

import-tar reads these tar formats:

- BORG: borg specific (PAX-based)

- PAX: POSIX.1-2001

- GNU: GNU tar

- POSIX.1-1988 (ustar)

- UNIX V7 tar

- SunOS tar with extended attributes

To import multiple tarballs into a single archive, they can be simply concatenated (e.g. using “cat”) into a single file, and imported with an `--ignore-zeros` option to skip through the stop markers between them.

## Examples

    # Export as an uncompressed tar archive
    $ borg export-tar Monday Monday.tar

    # Import an uncompressed tar archive
    $ borg import-tar Monday Monday.tar

    # Exclude some file types and compress using gzip
    $ borg export-tar Monday Monday.tar.gz --exclude '*.so'

    # Use a higher compression level with gzip
    $ borg export-tar --tar-filter="gzip -9" Monday Monday.tar.gz

    # Copy an archive from repoA to repoB
    $ borg -r repoA export-tar --tar-format=BORG archive - | borg -r repoB import-tar archive -

    # Export a tar, but instead of storing it on disk, upload it to a remote site using curl
    $ borg export-tar Monday - | curl --data-binary @- https://somewhere/to/POST

    # Remote extraction via 'tarpipe'
    $ borg export-tar Monday - | ssh somewhere "cd extracted; tar x"

    # Export sparse files (e.g. disk images) as sparse tar members (GNU sparse format 1.0)
    $ borg export-tar --sparse disk-images disk-images.tar

## Archives transfer script

Outputs a script that copies all archives from repo1 to repo2:

    for N I T in `borg list --format='{archive} {id} {time:%Y-%m-%dT%H:%M:%S}{NL}'`
    do
      echo "borg -r repo1 export-tar --tar-format=BORG aid:$I - | borg -r repo2 import-tar --timestamp=$T $N -"
    done

Kept:

- archive name, archive timestamp

- archive contents (all items with metadata and data)

Lost:

- some archive metadata (like the original command line, execution time, etc.)

Please note:

- all data goes over that pipe, again and again for every archive

- the pipe is dumb, there is no data or transfer time reduction there due to deduplication

- maybe add compression

- pipe over ssh for remote transfer

- maybe add `--sparse` to the export-tar command, so runs of all-zero chunks travel as a compact sparse map instead of literal zeros